/*
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.

 * Contributor(s) Name, Email, Jabber ID: 
 *
 *  Eric Murphy, ericmurphy@jabber.org, ericmurphy@jabber.org

 * Summary:
 *
 *  This handles all the IQ handling of Jabberzilla for JabberXM.

 * Change Log: 
 *
 *  2002.09.29:
 *
 *  1. Created file.
 *  2. Integrated roster code
 */

function IQ()
{
  this.jabberXMConstructor = 
         new Components.Constructor("@jabberxm.mozdev.org;1","JabberXM");
  this.jabberXM = new this.jabberXMConstructor();

  this.wrappedJSObject = this;

  this.rosteritemsResourceURI = 'http://jabberxm.mozdev.org/rdf#rosteritems';
  this.labelResourceURI = 'http://jabberxm.mozdev.org/rdf#label';
  this.typeResourceURI = 'http://jabberxm.mozdev.org/rdf#type';

  // Used for initializing presence
  this.showResourceURI  = 'http://jabberxm.mozdev.org/rdf#show';
  this.statusResourceURI = 'http://jabberxm.mozdev.org/rdf#status';

  this.roster = new this.RosterData(this.rosteritemsResourceURI);
  this.groups = new Object(); // associative array
}

IQ.prototype.packetIQ = function(packet)
{
  if(packet.attribs['type'] == 'result' && packet.attribs['id'] == 'register')
  {
    this.jabberXM.setAuthenticate(this.jabberXM.getUsername(),this.jabberXM.getPassword(),'Jabberzilla','0');
    this.jabberXM.authenticate('normal',this.jabberXM.getPassword());
  }
  else if(packet.attribs['type'] == 'error' && packet.attribs['id'] == 'register')
  {
    alert('"'+ this.jabberXM.getUsername() + '" already exists. Please try another username.');
    this.jabberXM.disconnect();
  }
  else
  {
    for(var i = 0; i < packet.children.length; i++)
    {
      switch(packet.children[i].name)
      {
        case 'vCard':
        {
          var vCard = packet.children[i];

          for (var x=0; x < vCard.children.length; x++) // Works, with lag
          {
            if (vCard.children[x].name=='EMAIL')
            {
              var Email =  (vCard.children[x].cdata);
              // window._content.location = ( 'mailto:' + Email + '?Subject=File Transfer' );
            }
          }
        }
        case 'query':
        {
          switch(packet.children[i].attribs["xmlns"])
          {
            case 'jabber:iq:roster':
            {
              this.packetRoster(packet.children[i]);
            }
            case 'jabber:iq:agents':
            {
              dump('Agents listing received.');
            }
            case 'jabber:iq:agent':
            {
              dump('Agent properties received.');
            }
            case 'jabber:iq:oob':
            {
              var oob = packet.children[i];
              dump('Out of band received.');
              // window._content.location = packet.children[0].children[0].cdata;
              // writeIQ(packet.attribs["from"],"result");
            }
            case 'jabber:iq:time':
            {
              var time = packet.children[i];
            }
            case 'jabber:iq:version':
            {
              var version = packet.children[i];
            }
            default:
              dump('Unknown query received.');
          }
        }
        case 'user':
          break;
        case 'conference':
          var jid = packet.attribs["from"];
      }
    }
  }
}

/**********************************************************************************/
// Below are functions for handling the roster

IQ.prototype.packetRoster = function(packet)
{
  for(var h = 0; h < packet.children.length; h++)
  {
    var user = new Object();

    switch(packet.children[h].name)
    {
      case 'item':
      {
        user.jid = packet.children[h].attribs["jid"];
        user.jid = user.jid.toLowerCase();
        user.nickname = packet.children[h].attribs["name"];

        user = this.changeTransportNames(user);
        child = packet.children[h];

        for(var j = 0; j < child.children.length; j++)
        {
          if(child.children[j].name == 'group')
            user.group = child.children[j].cdata;
        }

        if(user.group==null)
          user.group = 'Default';

        this.setGroup(user.group);

        subscription = packet.children[h].attribs["subscription"];

        if(subscription=='to' || subscription=='both')
          this.setUser(user.jid,user.nickname,'unavailable','',user.group);
        else
          this.setUser(user.jid,user.nickname,'unknown','unknown',user.group);
      }
      case 'user':
      {
        user.jid = packet.children[h].attribs["jid"];
        user.nickname = packet.children[h].attribs["name"];
        user.group = "Group";

        if(packet.children[h].attribs["type"]=="remove")
          this.removeUser(user.jid,user.group);
        else
        {
          //this.setGroup(user.group);
          //this.setUser(user.jid,user.nickname,'available','Online',user.group);
          //JabberXMModule.conferenceUserNameList[user.jid] = user.nickname;
        }
      }
      case 'conference':
      {
        for(j=0;j<packet.children[h].children.length;j++)
        {
          //users=packet.children[h].children;

          //user.jid = users[j].attribs["jid"];
          //user.nickname = users[j].attribs["name"];
          //user.group = "Group";

          //this.setGroup(user.group);
          //this.setUser(user.jid,user.nickname,'available','Online',user.group);
          //JabberXMModule.conferenceUserNameList[user.jid] = user.nickname;
        }
      }
    }
  }
}

IQ.prototype.setUser = function(jid,nickname,show,status,group)
{
  var contactResource = this.roster.rdf.GetResource(jid);

  this.roster.datasource.Assert
  (
    contactResource,
    this.roster.rdf.GetResource(this.labelResourceURI),
    this.roster.rdf.GetLiteral(nickname),
    true
  );

  this.roster.datasource.Assert
  (
    contactResource,
    this.roster.rdf.GetResource(this.typeResourceURI),
    this.roster.rdf.GetLiteral('contact'),
    true
  );

  this.roster.datasource.Assert
  (
    contactResource,
    this.roster.rdf.GetResource(this.showResourceURI),
    this.roster.rdf.GetLiteral('unavailable'),
    true
  );

  this.roster.datasource.Assert
  (
    contactResource,
    this.roster.rdf.GetResource(this.statusResourceURI),
    this.roster.rdf.GetLiteral(''),
    true
  );

  this.groups[group].AppendElement(contactResource);

  //JabberXMModule.presence.changeContactPresence(jid,'',show,status);
}

IQ.prototype.removeUser = function(jid,group)
{
  var contactResource = this.roster.rdf.GetResource(jid);
  this.groups[group].RemoveElement(contactResource,true);
}

IQ.prototype.setGroup = function(group)
{
  if (this.groups[group]==null)
  {
    // Moz bug 105759
    var groupResource = this.roster.rdf.GetResource('chrome://jabberzilla/content/main.xul#' + group);

    this.roster.datasource.Assert
    (
      groupResource,
      this.roster.rdf.GetResource(this.labelResourceURI),
      this.roster.rdf.GetLiteral(group),
      true
    );

    this.roster.datasource.Assert
    (
      groupResource,
      this.roster.rdf.GetResource(this.labelResourceURI),
      this.roster.rdf.GetLiteral(group),
      true
    );

    this.roster.datasource.Assert
    (
      groupResource,
      this.roster.rdf.GetResource(this.typeResourceURI),
      this.roster.rdf.GetLiteral('group'),
      true
    );

    contactsAnonymousResource = this.roster.rdf.GetAnonymousResource();

    this.roster.datasource.Assert
    (
      groupResource,
      this.roster.rdf.GetResource(this.rosteritemsResourceURI),
      contactsAnonymousResource,
      true
    );

    this.groups[group] = 
      this.roster.rdfc.MakeSeq(this.roster.datasource,contactsAnonymousResource);

    this.roster.sequence.AppendElement(groupResource);
  }
}

IQ.prototype.removeGroup = function(group)
{
  if (this.groups[group] != null)
  {
    //Remove Group Resource
  }
}

// frozen - eric@mozdev.org - 2001.10.16
IQ.prototype.changeTransportNames = function(user)
{
  if(user.jid.search('icq') != -1 && user.jid.search('@icq') == -1) {
    user.nickname = ('ICQ Network');
  }
  else if (user.jid.search('aim') != -1 && user.jid.search('@aim') == -1) {
    user.nickname = ('AIM Network');
  }
  else if (user.jid.search('msn') != -1 && user.jid.search('@msn') == -1) {
    user.nickname = ('MSN Network');
  }
  else if (user.jid.search('yahoo') != -1 && user.jid.search('@yahoo') == -1) {
    user.nickname = ('Yahoo Network');
  }
  return user;
}


/**********************************************************************************/
// This is an object for creating a list of data in RDF.

IQ.prototype.RosterData = function(uri)
{
  this.rdf = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);

  this.datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);

  this.root = this.rdf.GetResource('urn:root');
  this.anon = this.rdf.GetAnonymousResource();

  this.datasource.Assert(this.root,this.rdf.GetResource(uri),this.anon,true);

  this.rdfc = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils);

  this.sequence = this.rdfc.MakeSeq(this.datasource,this.anon);

  this.rdfs = Components.classes['@mozilla.org/rdf/container;1'].getService(Components.interfaces.nsIRDFContainer);
}